/******************************************************************************
 *   THREADS.CPP                                                              *
 ******************************************************************************		
 *                                                                            *
 * Define as chamadas da criaes das threads dos personagens                 *
 * serve como porto de acesso aos personagens e os controles do jogo         *
 *                                                                            *
 ******************************************************************************
 *                                                                            * 
 *    Trabalho Prtico de Automao em Tempo Real                             *
 *       6 Perodo de Engenharia de Controle e Automao                     *
 *           Universidade Federal de Minas Gerais                             *
 *                                                                            *
 *    Prof.:  Constantino Seixas Filho                                        *
 *                                                                            *
 *    Alunos: Rafael Cervolo                                                 *
 *            Thiago Barbosa                                                  *
 *                                                                            *
 *****************************************************************************/

#include "Classes.h"
// Como as threads sero funes de objetos, no foi possvel passar a 
// funo diretamente.
// Como soluo, foram criadas funes intermedirias para ligar a chamada
// da thread com a chamada da funo do objeto em especfico.
//---------------------------------------------------------------------------//
DWORD WINAPI ExecutaThreadInimigo(CInimigo *p)
{
Sleep(2000); //Tempo inicial antes de iniciar a partida
p->Vagueia();
return(0);
}
//---------------------------------------------------------------------------//
DWORD WINAPI ExecutaThreadJogador(CJogador *p)
{
p->AguardeComando();
return(0);
}
//---------------------------------------------------------------------------//
void CriaThreadInimigo(CInimigo *p,CHandle* pHandles)
{
//DWORD ID;
HANDLE hRetorno;
hRetorno = (HANDLE)_beginthreadex(NULL,0,(CAST_FUNCTION)ExecutaThreadInimigo,p,0,
						  (CAST_LPDWORD)&p->ID);
if (hRetorno)
{
//	p->SetID(ID);
	pHandles->AdicionaHandle(hRetorno,p->ID);
}
}
//----------------------------------------------------------------------------
void CriaThreadJogador(CJogador *p,CHandle* pHandles)
{
//DWORD ID;
HANDLE hRetorno;
hRetorno = (HANDLE)_beginthreadex(NULL,0,(CAST_FUNCTION)ExecutaThreadJogador,p,0,
						  (CAST_LPDWORD)&p->ID);
if (hRetorno)
{
	pHandles->AdicionaHandle(hRetorno,p->ID);
}
}
//----------------------------------------------------------------------------
